import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { IntegralLog, IntegralLogParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询积分明细
 */
export async function pageIntegralLog(params: IntegralLogParam) {
  const res = await request.get<ApiResult<PageResult<IntegralLog>>>(
    MODULES_API_URL + '/booking/integral-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询积分明细列表
 */
export async function listIntegralLog(params?: IntegralLogParam) {
  const res = await request.get<ApiResult<IntegralLog[]>>(
    MODULES_API_URL + '/booking/integral-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加积分明细
 */
export async function addIntegralLog(data: IntegralLog) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/integral-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改积分明细
 */
export async function updateIntegralLog(data: IntegralLog) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/integral-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除积分明细
 */
export async function removeIntegralLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/integral-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除积分明细
 */
export async function removeBatchIntegralLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/integral-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询积分明细
 */
export async function getIntegralLog(id: number) {
  const res = await request.get<ApiResult<IntegralLog>>(
    MODULES_API_URL + '/booking/integral-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
